const assert = require('assert');
const { Module, KIND_CHANNEL } = require('./module');

class Channel extends Module {
  /**
   * Create new instance of channel
   *
   * @param {object} identifier
   */
  constructor (identifier, version) {
    super(KIND_CHANNEL, identifier, version);

    assert('connect' in this, 'Channel must implement connect');
    assert('getUrls' in this, 'Channel must implement getUrls');
  }

  /**
   * Getter for proto
   */
  get proto () {
    return this.name;
  }

  incoming (socket) {
    return this.facade.incoming(socket);
  }
}

module.exports = { Channel };
