#!/usr/bin/env node

const path = require('path');
const USER_DIR = require('os').homedir();
const logger = require('twlv-logger')('twlv-swarm:cli');

function parse (argv = process.argv.splice(2)) {
  return require('yargs')
    .epilog('twlv p2p swarm')
    .commandDir('cmds')
    .demandCommand()
    .strict(true)
    .showHelpOnFail(true, 'Specify --help for available options')
    .version()
    .option('d', {
      alias: 'data-dir',
      describe: 'Data directory',
      default: path.join(USER_DIR, '.twlv'),
      coerce: value => path.resolve(value),
    })
    .alias('v', 'version')
    .help()
    .alias('h', 'help')
    .parse(argv);
}

process.on('unhandledRejection', err => logger.error('Unhandled rejection', err));
parse();
