# Swarm

Object to manage network by swarming peers.

```js
(async () => {
  let swarm = new Swarm();
  await swarm.connect('tcp://foo.bar:12121');
  await swarm.start();
})();
```

## Options

- networkId string
- storage

## Models

- DiscoveryDefinition object
  - kind string
  - ...
  + examples: { kind: 'boot' }

- ChannelDefinition object
  - kind string
  - ...
  + examples: { kind: 'http', port: 1212 }

- PeerUrl string
  + examples: http://192.168.1.101:1212

## Discovery Methods

Discovery method defines how to discover other peers.

Module implementation bound to swarm by node.js module. This kind of implementation must conform node module name as `twlv-discovery-<name>`

### Builtin

- boot
- peer
- dns (later)

### Module

- mdns

## Channel

Channel is a communication link between peers.

Module implementation bound to swarm by node.js module. This kind of implementation must conform node module name as `twlv-channel-<name>`

### Builtin

- http (rest)

### Module

- webrtc
- tcp
- udp

## Application

Application may run on top of swarm.

Module implementation bound to swarm by node.js module. This kind of implementation must conform node module name as `twlv-app-<name>`

### Builtin

- chat

### Module

- cryptocurrency
