const assert = require('assert');
const { Module, KIND_CHANNEL } = require('../module');

module.exports = function facade (swarm, { module }) {
  assert.ok(module instanceof Module, 'Facade must define module as instance of module');

  return {
    get address () {
      return swarm.address;
    },

    get networkId () {
      return swarm.networkId;
    },

    get advertisement () {
      return swarm.advertisement;
    },

    broadcast ({ command, payload }) {
      return swarm.broadcast({ kind: module.kind, module: module.name, command, payload });
    },

    send ({ address, command, payload }) {
      return swarm.send({ address, kind: module.kind, module: module.name, command, payload });
    },

    relay ({ address, command, payload }) {
      return swarm.relay({ address, kind: module.kind, module: module.name, command, payload });
    },

    lookup (address) {
      return swarm.lookup(address);
    },

    incoming (socket) {
      assert(module.kind === KIND_CHANNEL, 'Cannot incoming from non-channel module');
      return swarm.incoming(socket);
    },
  };
};
